Statistics
| Branch: | Revision:

root / create @ 5dc61974

History | View | Annotate | Download (3.9 kB)

1 79224631 Lance Albertson
#!/bin/bash
2 79224631 Lance Albertson
3 f1afb4b1 Lance Albertson
# Copyright (C) 2010 Oregon State University
4 79224631 Lance Albertson
#
5 79224631 Lance Albertson
# This program is free software; you can redistribute it and/or modify
6 79224631 Lance Albertson
# it under the terms of the GNU General Public License as published by
7 79224631 Lance Albertson
# the Free Software Foundation; either version 2 of the License, or
8 79224631 Lance Albertson
# (at your option) any later version.
9 79224631 Lance Albertson
#
10 79224631 Lance Albertson
# This program is distributed in the hope that it will be useful, but
11 79224631 Lance Albertson
# WITHOUT ANY WARRANTY; without even the implied warranty of
12 79224631 Lance Albertson
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
13 79224631 Lance Albertson
# General Public License for more details.
14 79224631 Lance Albertson
#
15 79224631 Lance Albertson
# You should have received a copy of the GNU General Public License
16 79224631 Lance Albertson
# along with this program; if not, write to the Free Software
17 79224631 Lance Albertson
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
18 79224631 Lance Albertson
# 02110-1301, USA.
19 79224631 Lance Albertson
20 79224631 Lance Albertson
set -e
21 79224631 Lance Albertson
22 6f0a1fef Lance Albertson
. common.sh
23 6f0a1fef Lance Albertson
24 e7a2d1ad Lance Albertson
debug set -x
25 e84e87cd Lance Albertson
26 5dc61974 Nikos Skalkotos
OS_FAMILY="linux"
27 5dc61974 Nikos Skalkotos
28 baca98f3 Lance Albertson
if [ "$IMAGE_TYPE" = "tarball" ] ; then
29 baca98f3 Lance Albertson
    IMAGE_FILE="${IMAGE_DIR}/${IMAGE_NAME}-${ARCH}.tar.gz"
30 baca98f3 Lance Albertson
elif [ "$IMAGE_TYPE" = "qemu" ] ; then
31 baca98f3 Lance Albertson
    IMAGE_FILE="${IMAGE_DIR}/${IMAGE_NAME}-${ARCH}.img"
32 640e7e45 Lance Albertson
elif [ "$IMAGE_TYPE" = "dump" ] ; then
33 640e7e45 Lance Albertson
    IMAGE_FILE="${IMAGE_DIR}/${IMAGE_NAME}-${ARCH}-root.dump"
34 baca98f3 Lance Albertson
fi
35 134c11c3 Lance Albertson
36 5dc61974 Nikos Skalkotos
. common_linux.sh
37 5dc61974 Nikos Skalkotos
38 fcce5224 Lance Albertson
if [ "$CDINSTALL" = "no" ] ; then
39 fcce5224 Lance Albertson
    # If the target device is not a real block device we'll first losetup it.
40 fcce5224 Lance Albertson
    # This is needed for file disks.
41 fcce5224 Lance Albertson
    if [ ! -b $blockdev ]; then
42 fcce5224 Lance Albertson
      ORIGINAL_BLOCKDEV=$blockdev
43 fcce5224 Lance Albertson
      blockdev=$($LOSETUP -sf $blockdev)
44 fcce5224 Lance Albertson
      CLEANUP+=("$LOSETUP -d $blockdev")
45 fcce5224 Lance Albertson
    fi
46 fcce5224 Lance Albertson
47 b05b1ab6 Lance Albertson
    if [ ! -f "$IMAGE_FILE" ] ; then
48 b05b1ab6 Lance Albertson
      log_error "Can't find image file: $IMAGE_FILE"
49 b05b1ab6 Lance Albertson
      exit 1
50 b05b1ab6 Lance Albertson
    fi
51 b05b1ab6 Lance Albertson
52 b05b1ab6 Lance Albertson
    # If the image is tarball based, then we need to manually create the
53 b05b1ab6 Lance Albertson
    # volumes, filesystems, etc
54 640e7e45 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" -o "${IMAGE_TYPE}" = "dump" ] ; then
55 b05b1ab6 Lance Albertson
        # Create 3 partitions, /boot, swap, & /
56 b05b1ab6 Lance Albertson
        format_disk0 $blockdev
57 b05b1ab6 Lance Albertson
    elif [ "${IMAGE_TYPE}" = "qemu" ] ; then
58 b05b1ab6 Lance Albertson
        # need a recent version of qemu for this
59 78422bb3 Lance Albertson
        ${QEMU_IMG} convert ${IMAGE_FILE} -O host_device ${blockdev} > /dev/null
60 b05b1ab6 Lance Albertson
    fi
61 b05b1ab6 Lance Albertson
62 8727c57d Lance Albertson
    # deploying something like a windows image, skip the rest
63 8727c57d Lance Albertson
    if [ "${NOMOUNT}" = "yes" ] ; then
64 8727c57d Lance Albertson
      cleanup
65 8727c57d Lance Albertson
      exit 0
66 8727c57d Lance Albertson
    fi
67 8727c57d Lance Albertson
68 494927a8 Lance Albertson
    filesystem_dev=$(map_disk0 $blockdev)
69 a1d43218 Lance Albertson
    CLEANUP+=("unmap_disk0 $blockdev")
70 494927a8 Lance Albertson
    root_dev=$(map_partition $filesystem_dev root)
71 494927a8 Lance Albertson
    boot_dev=$(map_partition $filesystem_dev boot)
72 494927a8 Lance Albertson
    swap_dev=$(map_partition $filesystem_dev swap)
73 fcce5224 Lance Albertson
74 640e7e45 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" -o "${IMAGE_TYPE}" = "dump" ] ; then
75 77449e7c Lance Albertson
        mkfs_disk0
76 3903b7f1 Lance Albertson
        root_uuid="$($VOL_ID $root_dev)"
77 b8a540bb Lance Albertson
        [ -n "$boot_dev" ] && sleep 1 && boot_uuid="$($VOL_ID $boot_dev)"
78 b8a540bb Lance Albertson
        [ -n "$swap_dev" ] && sleep 1 && swap_uuid="$($VOL_ID $swap_dev)"
79 b05b1ab6 Lance Albertson
    fi
80 fcce5224 Lance Albertson
81 916b6dd1 Lance Albertson
    TARGET=`mktemp -d` || exit 1
82 916b6dd1 Lance Albertson
    CLEANUP+=("rmdir $TARGET")
83 fcce5224 Lance Albertson
84 a1d43218 Lance Albertson
    # mount filesystems
85 77449e7c Lance Albertson
    mount_disk0 $TARGET
86 b05b1ab6 Lance Albertson
87 b05b1ab6 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" ] ; then
88 b05b1ab6 Lance Albertson
        # unpack image
89 916b6dd1 Lance Albertson
        tar pzxf $IMAGE_FILE -C $TARGET
90 640e7e45 Lance Albertson
    elif [ "${IMAGE_TYPE}" = "dump" ] ; then
91 0d9031a6 Lance Albertson
        root_dump="${IMAGE_FILE}"
92 78422bb3 Lance Albertson
        ( cd ${TARGET}; restore -r -y -f ${root_dump} > /dev/null )
93 77449e7c Lance Albertson
94 77449e7c Lance Albertson
        if [ -n "${boot_dev}" ] ; then
95 77449e7c Lance Albertson
            boot_dump="${IMAGE_FILE/root.dump/boot.dump}"
96 77449e7c Lance Albertson
            if [ ! -f "$boot_dump" ] ; then
97 77449e7c Lance Albertson
              log_error "Can't find image file: $boot_dump"
98 77449e7c Lance Albertson
              exit 1
99 77449e7c Lance Albertson
            fi
100 78422bb3 Lance Albertson
            ( cd ${TARGET}/boot; restore -r -y -f ${boot_dump} > /dev/null )
101 77449e7c Lance Albertson
        fi
102 b05b1ab6 Lance Albertson
    fi
103 e5ec11e4 Lance Albertson
104 3903b7f1 Lance Albertson
    if [ "${IMAGE_TYPE}" = "tarball" -o "${IMAGE_TYPE}" = "dump" ] ; then
105 3903b7f1 Lance Albertson
        setup_fstab $TARGET
106 3903b7f1 Lance Albertson
    fi
107 3903b7f1 Lance Albertson
108 9f4b2c31 Lance Albertson
    if [ "${INSTANCE_HV_serial_console}" = "True" ] ; then
109 9f4b2c31 Lance Albertson
        setup_console $TARGET
110 9f4b2c31 Lance Albertson
    fi
111 9f4b2c31 Lance Albertson
112 47e547ca Nikos Skalkotos
    filesystem_check $TARGET
113 47e547ca Nikos Skalkotos
114 fcce5224 Lance Albertson
    RUN_PARTS=`which run-parts`
115 fcce5224 Lance Albertson
116 fcce5224 Lance Albertson
    if [ -n "$RUN_PARTS" -a -n "$CUSTOMIZE_DIR" -a -d "$CUSTOMIZE_DIR" ]; then
117 916b6dd1 Lance Albertson
      TARGET=$TARGET
118 fcce5224 Lance Albertson
      BLOCKDEV=$blockdev
119 f7959feb Lance Albertson
      ROOT_DEV=$root_dev
120 c29e092d Lance Albertson
      BOOT_DEV=$boot_dev
121 ab462591 Constantinos Venetsanopoulos
      IMG_PASSWD=$IMG_PASSWD
122 ab462591 Constantinos Venetsanopoulos
      export TARGET SUITE BLOCKDEV ROOT_DEV BOOT_DEV IMAGE_TYPE IMG_PASSWD
123 fcce5224 Lance Albertson
      $RUN_PARTS $CUSTOMIZE_DIR
124 fcce5224 Lance Albertson
    fi
125 79224631 Lance Albertson
fi
126 79224631 Lance Albertson
127 79224631 Lance Albertson
# execute cleanups
128 79224631 Lance Albertson
cleanup
129 79224631 Lance Albertson
trap - EXIT
130 79224631 Lance Albertson
131 79224631 Lance Albertson
exit 0